/*
*Copyright(c)2014, Jeffrey Lee
*Allrightsreserved.
*
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef FUNCDEF_H
#define FUNCDEF_H

#include "common.h"

typedef uint32_t (*funcdeffunc)(const uint32_t *);

class funcdef
{
private:
	const char *name;
	uint32_t numparam;
	funcdeffunc func;
	const char *code;
	bool emitted;
public:
	funcdef(const char *n,uint32_t np,funcdeffunc f,const char *c,bool ni,bool si,bool no);

	bool numeric_input; /* True if all inputs must be numeric */
	bool same_input; /* True if inputs must be of same type */
	bool numeric_output; /* True if output is numeric */

	void emit();

	inline const char *getname() const { return name; }
	inline uint32_t getnumparam() const { return numparam; }

	inline uint32_t eval(const uint32_t *params) const { return func(params); }

	int treewalk_funcid;
};

extern funcdef *funcdef_eq;
extern funcdef *funcdef_land;
extern funcdef *funcdef_lnot;
extern funcdef *funcdef_lor;

extern funcdef *funcdef_get(const char *name);

#endif
